"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = __importStar(require("react"));
var react_redux_1 = require("react-redux");
var Messages_1 = require("x25/Messages");
var utility_1 = require("x25/utility");
var actions_1 = require("./actions");
var LoadDataItem = function (props) {
    var settings = props.settings, id = props.id, selectors = settings.selectors, data = (0, react_redux_1.useSelector)(function (state) { return selectors.getItem(state, id); }), hasError = (0, react_redux_1.useSelector)(function (state) { return selectors.getItemHasError(state, id); }), fetched = (0, react_redux_1.useSelector)(function (state) { return selectors.getItemIsFetched(state, id); }), isFetching = (0, react_redux_1.useSelector)(function (state) { return selectors.getIsFetchingItemInfo(state, id); }), shouldFetch = (0, react_redux_1.useSelector)(function (state) { return selectors.getShouldFetchItemInfo(state, id); }), dispatch = (0, react_redux_1.useDispatch)(), fetchItem = function () {
        dispatch((0, actions_1.fetchItem)(__assign(__assign({}, settings), { id: id }))).catch(function (err) {
            // eslint-disable-next-line no-console
            console.log("err", err);
        });
    };
    React.useEffect(function () {
        if (shouldFetch) {
            fetchItem();
        }
    }, [shouldFetch, isFetching, hasError]);
    if (isFetching && !fetched) {
        if (props.sm) {
            return React.createElement(Messages_1.LoadingMessage, { sm: true });
        }
        return (React.createElement("div", { className: "text-center" },
            React.createElement(Messages_1.LoadingMessage, { message: utility_1.words.LoadingData })));
    }
    if (hasError) {
        if (props.sm) {
            return (React.createElement(Messages_1.ErrorMessage, { message: (React.createElement("i", { className: "fa fa fa-exclamation-triangle text-warning" })) }));
        }
        return React.createElement(Messages_1.LargeErrorMessage, { message: utility_1.words.ThereWasAProblem, onRetry: fetchItem });
    }
    if (!data) {
        return null;
    }
    return props.children;
};
exports.default = LoadDataItem;
//# sourceMappingURL=LoadDataItem.js.map