"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var Immutable = __importStar(require("immutable"));
var react_1 = __importStar(require("react"));
var react_redux_1 = require("react-redux");
var Messages_1 = require("x25/Messages");
var utility_1 = require("x25/utility");
var LoadingButton_1 = __importDefault(require("./LoadingButton"));
var selectors_1 = __importDefault(require("./selectors"));
var LoadPaginator = function (props) {
    var token = props.token, settings = props.settings, _a = (0, react_redux_1.useSelector)(function (state) { return (selectors_1.default.getPaginators(state, settings.key)); }), list = _a.list, entities = _a.entities, currentPage = selectors_1.default.getCurrentView(list, token), isFetching = selectors_1.default.isPageFetching(list, token, currentPage), isFetched = selectors_1.default.isPageFetched(list, token, currentPage), resultsUpTo = (selectors_1.default.getResultsUpToPage(list, token, entities, currentPage, settings.rowsPerLoad)), items = settings.manipulateItems(resultsUpTo), total = selectors_1.default.getCurrentTotalResultsCount(list, token), hasProblems = selectors_1.default.hasPageProblems(list, token), paginator = Immutable.Map({
        currentPage: currentPage,
        hasProblems: hasProblems,
        isFetched: isFetched,
        isFetching: isFetching,
        items: items,
        total: total,
    }), dispatch = (0, react_redux_1.useDispatch)(), resetView = function (currentToken) { return dispatch(settings.resetView(currentToken)); }, changeView = function (data) { return dispatch(settings.changeView(data)); }, loadData = function (page) { return dispatch(settings.requestPage(page, token)); }, showLoading = paginator.get("total") !== items.size, shouldFetch = !isFetched && !isFetching && !props.preventFetching, handleLoadMoreClick = function () {
        if (hasProblems) {
            loadData(currentPage);
        }
        else {
            changeView({
                token: token,
                view: currentPage + 1,
            });
        }
    };
    (0, react_1.useEffect)(function () {
        if (shouldFetch) {
            loadData(currentPage);
        }
    }, [shouldFetch]);
    (0, react_1.useEffect)(function () { return function () { return resetView(token); }; }, []);
    if (props.preventAutoLoading) {
        return (react_1.default.cloneElement(props.children, {
            token: props.token,
            settings: props.settings,
            paginator: paginator,
            changeView: changeView,
            resetView: resetView,
            loadData: loadData,
        }));
    }
    if (items.size === 0 && (isFetching || !isFetched)) {
        return react_1.default.createElement(Messages_1.LoadingMessage, { message: utility_1.words.LoadingData });
    }
    if (hasProblems && currentPage === 1) {
        return (react_1.default.createElement(Messages_1.LargeErrorMessage, { message: utility_1.words.ThereWasAProblem, onRetry: handleLoadMoreClick }));
    }
    return (react_1.default.createElement("div", { className: "mb-3" },
        react_1.default.cloneElement(props.children, {
            token: props.token,
            settings: props.settings,
            paginator: paginator,
            changeView: changeView,
            resetView: resetView,
            loadData: loadData,
        }),
        showLoading && !props.preventAutoLoading ? (react_1.default.createElement(LoadingButton_1.default, { fetchMore: handleLoadMoreClick, hasProblems: hasProblems, isFetching: isFetching })) : null));
};
exports.default = LoadPaginator;
//# sourceMappingURL=LoadPaginator.js.map