"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
/* eslint-disable @typescript-eslint/no-empty-function */
/* eslint-disable no-useless-constructor */
/* eslint-disable class-methods-use-this */
/* eslint-disable react/sort-comp */
var react_1 = __importDefault(require("react"));
var react_intersection_observer_1 = require("react-intersection-observer");
var Messages_1 = require("x25/Messages");
var utility_1 = require("x25/utility");
var LoadingButton = function (props) {
    var isFetching = props.isFetching, hasProblems = props.hasProblems, fetchMore = props.fetchMore, _a = (0, react_intersection_observer_1.useInView)({}), ref = _a[0], inView = _a[1];
    react_1.default.useEffect(function () {
        if (!isFetching && !hasProblems && inView) {
            fetchMore();
        }
    }, [isFetching, hasProblems, inView]);
    return (react_1.default.createElement("button", { className: "btn btn-link d-print-none", disabled: isFetching, onClick: fetchMore, ref: ref, type: "button" }, isFetching ? utility_1.words.LoadingData : utility_1.words.LoadMore));
}, LoadingWrapper = function (props) {
    var isFetching = props.isFetching, hasProblems = props.hasProblems;
    return (react_1.default.createElement("div", { className: "text-center my-2" },
        hasProblems ? (react_1.default.createElement(Messages_1.ErrorMessage, { message: utility_1.words.ThereWasAProblem })) : null,
        isFetching ? (react_1.default.createElement(Messages_1.LoadingMessage, { message: utility_1.words.LoadingData, sm: true })) : (react_1.default.createElement(LoadingButton, __assign({}, props)))));
};
exports.default = LoadingWrapper;
//# sourceMappingURL=LoadingButton.js.map