"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.fetchItem = void 0;
var superagent_1 = __importDefault(require("superagent"));
var requestPage = function (_a) {
    var endpoint = _a.endpoint, endpointCb = _a.endpointCb, manageEntity = _a.manageEntity, resultsKey = _a.resultsKey, totalKey = _a.totalKey, pageArgName = _a.pageArgName, idKey = _a.idKey, page = _a.page, token = _a.token;
    return ({
        type: "@@redux-paginator-immutable/REQUEST_PAGE",
        meta: {
            endpoint: endpoint,
            endpointCb: endpointCb,
            manageEntity: manageEntity,
            resultsKey: resultsKey,
            totalKey: totalKey,
            pageArgName: pageArgName,
            idKey: idKey,
        },
        payload: {
            page: page,
            token: token,
        },
    });
}, receivePage = function (_a) {
    var endpoint = _a.endpoint, endpointCb = _a.endpointCb, manageEntity = _a.manageEntity, pageArgName = _a.pageArgName, idKey = _a.idKey, page = _a.page, token = _a.token, items = _a.items, error = _a.error, total = _a.total;
    return ({
        type: "@@redux-paginator-immutable/RECEIVE_PAGE",
        meta: {
            endpoint: endpoint,
            endpointCb: endpointCb,
            manageEntity: manageEntity,
            pageArgName: pageArgName,
            idKey: idKey,
        },
        payload: {
            page: page,
            token: token,
            items: items,
            error: error,
            total: total,
        },
    });
}, resetView = function (endpoint, token) { return ({
    type: "@@redux-paginator-immutable/RESET_VIEW",
    meta: {
        endpoint: endpoint,
    },
    payload: {
        token: token,
    },
}); }, changeView = function (endpoint, _a) {
    var token = _a.token, view = _a.view;
    return ({
        type: "@@redux-paginator-immutable/CHANGE_VIEW",
        meta: {
            endpoint: endpoint,
        },
        payload: {
            token: token,
            view: view,
        },
    });
}, clearData = function (endpoint) { return ({
    type: "@@redux-paginator-immutable/CLEAR_DATA",
    meta: {
        endpoint: endpoint,
    },
}); };
var fetchDataItemRequest = function (_a) {
    var dataItemURL = _a.dataItemURL, normalizeDataItem = _a.normalizeDataItem, id = _a.id;
    return new Promise(function (resolve, reject) { return (superagent_1.default.
        get("".concat(dataItemURL, "/").concat(id)).
        set("Accept", "application/json").
        end(normalizeDataItem(resolve, reject))); });
};
var fetchItem = function (things) { return ({
    type: "@@redux-paginator-immutable/FETCH_ITEM_DATA",
    payload: fetchDataItemRequest(things),
    meta: {
        id: things.id,
        endpoint: things.endpoint,
    },
}); };
exports.fetchItem = fetchItem;
exports.default = {
    clearData: clearData,
    requestPage: requestPage,
    receivePage: receivePage,
    resetView: resetView,
    changeView: changeView,
};
//# sourceMappingURL=actions.js.map