"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var vitest_1 = require("vitest");
var agent_1 = require("./agent");
(0, vitest_1.describe)("buildSuffix", function () {
    (0, vitest_1.test)("should correctly build the url suffix when simple params are provided", function () {
        (0, vitest_1.expect)((0, agent_1.buildSuffix)("p", 1, "foo=bar")).
            toEqual("?foo=bar&p=1");
    });
    (0, vitest_1.test)("should correctly build the url suffix when less simple params are provided", function () {
        (0, vitest_1.expect)((0, agent_1.buildSuffix)("p", 1, "foo=bar&baz=foo")).
            toEqual("?baz=foo&foo=bar&p=1");
    });
    (0, vitest_1.test)("should correctly build the url suffix when params contains no extractable query params", function () {
        (0, vitest_1.expect)((0, agent_1.buildSuffix)("p", 1, "foo/bar")).
            toEqual("foo/bar?p=1");
    });
    (0, vitest_1.test)('should correctly build the url suffix when "params" is not provided', function () {
        (0, vitest_1.expect)((0, agent_1.buildSuffix)("p", 1, "")).
            toEqual("?p=1");
    });
    (0, vitest_1.test)("should correctly build the url suffix when complex params are provided", function () {
        (0, vitest_1.expect)((0, agent_1.buildSuffix)("p", 1, "foo/bar?bar=biz&baz=foo")).
            toEqual("foo/bar?baz=foo&bar=biz&p=1");
    });
});
//# sourceMappingURL=agent.test.js.map