"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createPaginator = exports.onlyForEndpoint = void 0;
var defaultRowsPerLoad = 25;
var Immutable = __importStar(require("immutable"));
var reducers_1 = require("./reducers");
var actions_1 = __importDefault(require("./actions"));
var getEndpoint = function (data) {
    if (typeof data === "object") {
        return {
            path: data.path,
            cb: data.cb,
        };
    }
    return {
        path: data,
        cb: null,
    };
};
var onlyForEndpoint = function (endpoint, reducer) { return function (state, action) {
    if (state === void 0) { state = Immutable.Map(); }
    if (typeof action.meta === "undefined" || action.meta.endpoint !== endpoint) {
        return state;
    }
    return reducer(state, action);
}; }, createPaginator = function (endpointData, settings) {
    var _a = getEndpoint(endpointData), endpoint = _a.path, endpointCb = _a.cb, key = settings.key, normalizeDataItem = settings.normalizeDataItem, dataItemURL = settings.dataItemURL, manageEntity = settings.manageEntity, resultsKey = settings.resultsKey, _b = settings.totalKey, totalKey = _b === void 0 ? "Total" : _b, _c = settings.pageArgName, pageArgName = _c === void 0 ? "page" : _c, _d = settings.idKey, idKey = _d === void 0 ? "ID" : _d, _e = settings.rowsPerLoad, rowsPerLoad = _e === void 0 ? defaultRowsPerLoad : _e, _f = settings.manipulateItems, manipulateItems = _f === void 0 ? function (items) { return items; } : _f, endpointedActions = {
        requestPage: function (page, token) { return actions_1.default.requestPage({
            endpoint: endpoint,
            endpointCb: endpointCb,
            manageEntity: manageEntity,
            resultsKey: resultsKey,
            totalKey: totalKey,
            pageArgName: pageArgName,
            idKey: idKey,
            page: page,
            token: token,
        }); },
        resetView: function (token) {
            return actions_1.default.resetView(endpoint, token);
        },
        changeView: function (_a) {
            var view = _a.view, token = _a.token;
            return actions_1.default.changeView(endpoint, {
                view: view,
                token: token,
            });
        },
        clearData: function () {
            return actions_1.default.clearData(endpoint);
        },
    };
    return __assign({ key: key, normalizeDataItem: normalizeDataItem, dataItemURL: dataItemURL, manipulateItems: manipulateItems, rowsPerLoad: rowsPerLoad, manageEntity: manageEntity, resultsKey: resultsKey, endpoint: endpoint, pagesReducer: (0, exports.onlyForEndpoint)(endpoint, reducers_1.pages), itemsReducer: (0, exports.onlyForEndpoint)(endpoint, reducers_1.items), dataItemsReducer: (0, exports.onlyForEndpoint)(endpoint, reducers_1.dataItems) }, endpointedActions);
};
exports.onlyForEndpoint = onlyForEndpoint, exports.createPaginator = createPaginator;
//# sourceMappingURL=createPaginator.js.map