"use strict";
/* eslint-disable max-len, no-undefined, no-magic-numbers */
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var vitest_1 = require("vitest");
var actions_1 = __importDefault(require("./actions"));
var createPaginator_1 = require("./createPaginator");
var requestPage = actions_1.default.requestPage;
(0, vitest_1.describe)("createPaginator", function () {
    (0, vitest_1.test)("should create correct request action creator", function () {
        var paginator = (0, createPaginator_1.createPaginator)("some/api/endpoint", {
            pageArgName: "p",
            idKey: "id_field",
            resultsKey: "results",
            totalKey: "count",
        }), action = paginator.requestPage(42, "foo=bar");
        (0, vitest_1.expect)(action).
            toEqual(requestPage({
            endpoint: "some/api/endpoint",
            endpointCb: null,
            resultsKey: "results",
            totalKey: "count",
            pageArgName: "p",
            idKey: "id_field",
            page: 42,
            token: "foo=bar",
        }));
    });
});
//# sourceMappingURL=createPaginator.test.js.map