"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.dataItems = exports.items = exports.pages = void 0;
var Immutable = __importStar(require("immutable"));
var actionTypes_1 = require("./actionTypes");
var reducerItemData = __importStar(require("./reducerItemData"));
var reducerOperations = __importStar(require("./reducerOperations"));
var pages = function (state, action) {
    if (state === void 0) { state = Immutable.Map(); }
    switch (action.type) {
        case actionTypes_1.REQUEST_PAGE:
            return reducerOperations.requestPage(state, action);
        case actionTypes_1.RECEIVE_PAGE:
            return reducerOperations.receivePage(state, action);
        case actionTypes_1.RESET_VIEW:
            return reducerOperations.resetView(state, action);
        case actionTypes_1.CHANGE_VIEW:
            return reducerOperations.changeView(state, action);
        case actionTypes_1.FETCH_CURRENT_COMPANY_INFO_PENDING:
        case actionTypes_1.CLEAR_DATA:
            return state.clear();
        default:
            return state;
    }
}, items = function (state, action) {
    if (state === void 0) { state = Immutable.Map(); }
    switch (action.type) {
        case actionTypes_1.RECEIVE_PAGE:
            return reducerOperations.receivePageItems(state, action);
        case actionTypes_1.FETCH_CURRENT_COMPANY_INFO_PENDING:
        case actionTypes_1.CLEAR_DATA:
            return state.clear();
        default:
            return state;
    }
}, dataItems = function (state, action) {
    if (state === void 0) { state = Immutable.Map(); }
    switch (action.type) {
        case actionTypes_1.RECEIVE_PAGE:
            return reducerOperations.receivePageItems(state, action);
        case actionTypes_1.FETCH_ITEM_DATA_PENDING:
            return reducerItemData.fetchItemDataPending(state, action);
        case actionTypes_1.FETCH_ITEM_DATA_REJECTED:
            return reducerItemData.fetchItemDataRejected(state, action);
        case actionTypes_1.FETCH_ITEM_DATA_FULFILLED:
            return reducerItemData.fetchItemDataFulFilled(state, action);
        case actionTypes_1.FETCH_CURRENT_COMPANY_INFO_PENDING:
        case actionTypes_1.CLEAR_DATA:
            return state.clear();
        default:
            return state;
    }
};
exports.pages = pages, exports.items = items, exports.dataItems = dataItems;
//# sourceMappingURL=reducers.js.map