"use strict";
/* eslint-disable max-len, no-undefined, max-lines-per-function */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var Immutable = __importStar(require("immutable"));
var vitest_1 = require("vitest");
var actions_1 = __importDefault(require("./actions"));
var reducers_1 = require("./reducers");
var requestPage = actions_1.default.requestPage, receivePage = actions_1.default.receivePage, requestPageAction = requestPage({
    endpoint: "some/api/endpoint",
    resultsKey: "results",
    totalKey: "total",
    pageArgName: "p",
    idKey: "id",
    page: 2,
    token: "foo=bar",
}), receivePageAction = receivePage({
    endpoint: "some/api/endpoint/",
    pageArgName: "p",
    idKey: "id",
    page: 2,
    token: "foo=bar",
    items: [
        {
            id: "baz",
            fooField: "bazValue",
        },
        {
            id: "bar",
            fooField: "barValue",
        },
    ],
    total: 2,
});
(0, vitest_1.describe)("pages reducer", function () {
    (0, vitest_1.test)("should return the state by default", function () {
        var theState = Immutable.Map({
            some: "state",
        }), theAction = { type: "some action" }, result = (0, reducers_1.pages)(theState, theAction), expectedState = Immutable.Map({
            some: "state",
        });
        (0, vitest_1.expect)(result).toEqual(expectedState);
    });
    (0, vitest_1.test)("should initialize the pages map with a new page entry when requesting new page", function () {
        var state = (0, reducers_1.pages)(undefined, requestPageAction);
        (0, vitest_1.expect)(state).toEqual(Immutable.Map({
            "foo=bar": Immutable.Map({
                page: 2,
                error: false,
                fetching: true,
                fetched: false,
                view: 1,
                token: "foo=bar",
                ids: Immutable.List(),
            }),
        }));
    });
    (0, vitest_1.test)("should populate the pages map at the page url key with the item ids", function () {
        var state = (0, reducers_1.pages)(Immutable.Map({
            "foo=bar": Immutable.Map({
                page: 2,
                token: "foo=bar",
                ids: Immutable.List(),
                fetching: true,
                fetched: false,
            }),
        }), receivePageAction);
        (0, vitest_1.expect)(state).toEqual(Immutable.Map({
            "foo=bar": Immutable.Map({
                page: 2,
                token: "foo=bar",
                ids: Immutable.List([
                    "baz",
                    "bar",
                ]),
                fetching: false,
                fetched: true,
                error: false,
                total: 2,
            }),
        }));
    });
});
(0, vitest_1.describe)("items reducer", function () {
    (0, vitest_1.test)("should populate the items map with item received", function () {
        var state = (0, reducers_1.items)(undefined, receivePageAction);
        (0, vitest_1.expect)(state).toEqual(Immutable.Map({
            "baz": Immutable.Map({
                id: "baz",
                fooField: "bazValue",
            }),
            "bar": Immutable.Map({
                id: "bar",
                fooField: "barValue",
            }),
        }));
    });
});
//# sourceMappingURL=reducers.test.js.map