"use strict";
/* eslint-disable max-len, no-undefined, max-lines-per-function, no-magic-numbers */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var Immutable = __importStar(require("immutable"));
var vitest_1 = require("vitest");
var selectors_1 = __importDefault(require("./selectors"));
var getCurrentTotalResultsCount = selectors_1.default.getCurrentTotalResultsCount, getAllResults = selectors_1.default.getAllResults, getResultsUpToPage = selectors_1.default.getResultsUpToPage, isPageFetched = selectors_1.default.isPageFetched, isPageFetching = selectors_1.default.isPageFetching, getCurrentView = selectors_1.default.getCurrentView, paginator = Immutable.Map({
    "foo=bar": Immutable.Map({
        page: 3,
        token: "foo=bar",
        ids: Immutable.List([
            1,
            2,
            3,
            7,
            8,
            9,
        ]),
        total: 42,
        view: 2,
        fetching: false,
        fetched: true,
    }),
    "foo=baz": Immutable.Map({
        page: 1,
        token: "foo=baz",
        ids: Immutable.List([
            1,
            4,
            6,
        ]),
        fetching: false,
        fetched: true,
        total: 17,
        view: 1,
    }),
}), items = Immutable.Map({
    "1": Immutable.Map({
        data: "foo1",
        id: 1,
    }),
    "2": Immutable.Map({
        data: "foo2",
        id: 2,
    }),
    "3": Immutable.Map({
        data: "foo3",
        id: 3,
    }),
    "4": Immutable.Map({
        data: "foo4",
        id: 4,
    }),
    "5": Immutable.Map({
        data: "foo5",
        id: 5,
    }),
    "6": Immutable.Map({
        data: "foo6",
        id: 6,
    }),
    "7": Immutable.Map({
        data: "foo7",
        id: 7,
    }),
    "8": Immutable.Map({
        data: "foo8",
        id: 8,
    }),
    "9": Immutable.Map({
        data: "foo9",
        id: 9,
    }),
});
(0, vitest_1.describe)("selectors", function () {
    (0, vitest_1.test)("getAllResults should select all the items ids for pages with same params than the current page", function () {
        (0, vitest_1.expect)(getAllResults(paginator, "foo=bar", items)).
            toEqual(Immutable.List([
            Immutable.Map({
                data: "foo1",
                id: 1,
            }),
            Immutable.Map({
                data: "foo2",
                id: 2,
            }),
            Immutable.Map({
                data: "foo3",
                id: 3,
            }),
            Immutable.Map({
                data: "foo7",
                id: 7,
            }),
            Immutable.Map({
                data: "foo8",
                id: 8,
            }),
            Immutable.Map({
                data: "foo9",
                id: 9,
            }),
        ]));
    });
    (0, vitest_1.test)("getResultsUpToPage should select all the items ids for pages with same params than the current page", function () {
        (0, vitest_1.expect)(getResultsUpToPage(paginator, "foo=bar", items, 2, 2)).
            toEqual(Immutable.List([
            Immutable.Map({
                data: "foo1",
                id: 1,
            }),
            Immutable.Map({
                data: "foo2",
                id: 2,
            }),
            Immutable.Map({
                data: "foo3",
                id: 3,
            }),
            Immutable.Map({
                data: "foo7",
                id: 7,
            }),
        ]));
    });
    (0, vitest_1.test)("getCurrentTotalResultsCount should return the total count for the current params of the provided name", function () {
        (0, vitest_1.expect)(getCurrentTotalResultsCount(paginator, "foo=bar")).
            toEqual(42);
    });
    (0, vitest_1.test)("getCurrentTotalResultsCount should return 0 if current page url is undefined for the provided name", function () {
        (0, vitest_1.expect)(getCurrentTotalResultsCount(paginator, "name3")).
            toEqual(0);
    });
    (0, vitest_1.test)("isPageFetching should return whether the current page is fetching or not for the provided name", function () {
        (0, vitest_1.expect)(isPageFetching(paginator, "foo=bar", 1)).
            toEqual(false);
    });
    (0, vitest_1.test)("isPageFetched should return whether the current page is fetched or not for the provided name", function () {
        (0, vitest_1.expect)(isPageFetched(paginator, "foo=bar", 1)).
            toEqual(true);
    });
    (0, vitest_1.test)("isPageFetched should return whether the current page is fetched or not for the provided name", function () {
        (0, vitest_1.expect)(isPageFetched(paginator, "foo=bar", 4)).
            toEqual(false);
    });
    (0, vitest_1.test)("getCurrentView should return 1 if there is no view point", function () {
        (0, vitest_1.expect)(getCurrentView(paginator, "foo=bat")).
            toEqual(1);
    });
    (0, vitest_1.test)("getCurrentView should return the value if it exists", function () {
        (0, vitest_1.expect)(getCurrentView(paginator, "foo=bar")).
            toEqual(2);
    });
});
//# sourceMappingURL=selectors.test.js.map